ODA({is: 'oda-markdown-editor', imports: '@oda/simplemde-editor, @oda/divider, @oda/md-viewer, @oda/ace-editor',
    template:`  
        <style>
           :host{
                @apply --horizontal;
                @apply --flex;
                min-height: 20px;
            }
        </style>
        <div style="display: flex; flex: 1; overflow: hidden; height: 100%">
            <div ~if="editMode" style="width: 50%; overflow: hidden; position: relative">
                <oda-simplemde-editor ~if="type==='simplemde'" :value="src" @change="onchange"></oda-simplemde-editor>
                <oda-ace-editor ~if="type==='ace'" :src="src" @change="onchange" class="flex" highlight-active-line="false" show-print-margin="false" theme="solarized_light" mode="markdown" min-lines=1></oda-ace-editor></oda-ace-editor>
            </div>
            <oda-divider ~if="editMode" size="3" color=transparent></oda-divider>
            <div style="overflow-x: hidden; flex: 1">
                <oda-md-viewer ~if="fount" class="flex" :src="fount" :edit-mode="editMode && !readOnly" padding="0 2px"></oda-md-viewer>
                <oda-md-viewer ~if="!fount" class="flex" :srcmd="source" :edit-mode="editMode && !readOnly" padding="0 2px"></oda-md-viewer>
            </div>
        </div>
    `,
    $public:{
        type:{
            $def: 'simplemde',
            $list: ['simplemde', 'ace'],
            set(n) {
                this.src = this.source;
            },
            $save: true
        },
        editMode: {
            $def: false,
            set(n) {
                this.src = this.source;
            }
        },
        readOnly: false
    },
    src: '',
    fount: '',
    set source(v) {
        if (v !== undefined && !this.src)
            this.src = v;
    },
    onchange(e) {
        this.source = e.detail.value;
    }
})
